#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <syslog.h>
#include <time.h>
#include "locallog.h"

// default to syslog default
// contract presumption: no checks on calls; calls are presumed correct
FILE* logfile = NULL;
int filepriority = LOG_CRIT;

void lopenlog (const char *ident, int option, int facility)
{ if (facility != OUTPUT_TO_FILE) openlog (ident, option, facility);
  else logfile = fopen (ident, "a+"); }

void lsyslog (int priority, const char *format, ...)
{ va_list ap;
  char buf [64];
  int len;
  time_t tt;
  va_start (ap, format);
  if (logfile == NULL) vsyslog (priority, format, ap);
  else if (priority <= filepriority) 
  { tt = time (NULL);
    asctime_r (localtime (&tt), buf);
    len = strlen (buf);
    if (len > 0)
    { buf [len-1] = ' '; 
      fprintf (logfile, buf); }
    vfprintf (logfile, format, ap); 
    fprintf (logfile, "\n"); }
  va_end (ap); }

void lcloselog (void)
{ if (logfile != NULL) fclose (logfile);
  else closelog (); }

int lsetlogmask (int mask)
{ if (logfile == NULL) return setlogmask (mask);
  int old = filepriority;
  filepriority = mask & 0x1F;
  return old; }

